interface(quiet=true);
kernelopts(opaquemodules=false);
kernelopts(assertlevel=2);

infolevel[bounds] := 10;
infolevel[nth_term] := 10;

precfactor := 5;

nbt := proc(f, a, forcedeq:=`none`)
    local deq, rec, val, err;
    print("Test : ", subs(z=a, f(z)));
    if forcedeq = `none` then
        deq := diffeqtohomdiffeq(holexprtodiffeq(f(z),y(z)),y(z));
    else
        deq := forcedeq;
    end if;
    val := ac_eval(deq,y(z),[0,a],prec);
    err := evalf[prec*precfactor](val - ac_eval(deq,y(z),[0,a],prec*precfactor));
    #err := evalf[prec*precfactor](val - f(a));
end proc;

for prec in [100, 1000] do
  print("Precision : ", prec);
  nbt(z -> arctan(z),1/2);
  nbt(z -> arctan(z),3/4);
  nbt(z -> cos(z)/(1-z), 1/3);
  nbt(
    z->-MathieuSPrime(0,1,1/2*Pi)/(MathieuS(0,1,1/2*Pi)*MathieuCPrime(0,1,1/2*Pi)-MathieuSPrime(0,1,1/2*Pi)*MathieuC(0,1,1/2*Pi))*MathieuC(0,1,arccos(z))+1/(MathieuS(0,1,1/2*Pi)*MathieuCPrime(0,1,1/2*Pi)-MathieuSPrime(0,1,1/2*Pi)*MathieuC(0,1,1/2*Pi))*MathieuCPrime(0,1,1/2*Pi)*MathieuS(0,1,arccos(z)),
    1/3,
    {(1-z^2)*diff(y(z),z,z)-z*diff(y(z),z)+2*(1-2*z^2)*y(z), y(0)=1, D(y)(0)=0});
 nbt(z -> exp(z/(1-z^2)), 1/3);
  nbt(z -> erf(z/(1-z)), 1/3);
  nbt(z -> exp(z),-100);
  nbt(z -> AiryAi(z),4*I+4);
end do;

